#include <vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------

#include "dlgMain.h"
//---------------------------------------------------------------------------

#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------

TFormMain *FormMain;
//---------------------------------------------------------------------------

__fastcall TFormMain::TFormMain(TComponent* Owner) : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::btnPersonAnlegenClick(TObject *Sender)
{
	TJSONObject *pPerson, *pPersonPointer, *pAdresse;
	TBackendEntityValue entity;

	// JSON-Objekt erzeugen
	pPerson = new TJSONObject();
	// Name
	pPerson->AddPair("Name", this->edtName->Text);
	// Vorname
	pPerson->AddPair("Vorname", this->edtVorname->Text);

	// Objekt an Parse "schicken", "entity" enthlt die erzeugte objectId
	this->BackendStorage->Storage->CreateObject("Person", pPerson, entity);

	// JSON-Objekt erzeugen
	pPersonPointer = new TJSONObject();
	// Typ "Pointer"
	pPersonPointer->AddPair("__type", "Pointer");
	// Klassenname (wo soll der Zeiger hinzeigen)
	pPersonPointer->AddPair("className", "Person");
	// Object-ID (auf welchen Satz soll der Zeiger zeigen?)
	pPersonPointer->AddPair("objectId", entity.ObjectID);

	// Den Adressen-Datensatz basteln
	pAdresse = new TJSONObject();
	pAdresse->AddPair("Person", pPersonPointer);
	pAdresse->AddPair("PLZ", this->edtPLZ->Text);
	pAdresse->AddPair("Ort", this->edtOrt->Text);
	pAdresse->AddPair("Strasse", this->edtStrasse->Text);

	// Adressen-Satz an Parse "schicken"
	this->BackendStorage->Storage->CreateObject("Adressen", pAdresse, entity);

	// Speicher wieder freigeben
	delete pPerson;
	delete pAdresse;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::btnLesenClick(TObject *Sender)
{
	TJSONObject *pPerson, *pPersonAbfrage;

	// Der "Abfragetyp"
	this->BackendQuery->BackendService = "Storage";
	// Aus welcher Parse-Klasse wollen wir Daten lesen?
	this->BackendQuery->BackendClassName = "Person";
	// Wie soll sortiert werden?
	this->BackendQuery->QueryLines->Clear();
	this->BackendQuery->QueryLines->Add("order=Name");

	// Das JSON-Objekt fuer die Abfrage basteln
	pPersonAbfrage = new TJSONObject();
	pPersonAbfrage->AddPair("Name", "Maier");

	// Die Einschraenkung hinzufuegen
	this->BackendQuery->QueryLines->Add("where=" + pPersonAbfrage->ToString());

	// Die Abfrage ausfuehren
	this->BackendQuery->Execute();

	// Die alten Zeilen aus dem Memofeld loeschen
	this->mePersonen->Lines->Clear();

	// Die Ergebnisliste durchlaufen
	for(int i = 0; i < this->BackendQuery->JSONResult->Count; ++i)
	{
		pPerson = static_cast<TJSONObject*>(this->BackendQuery->JSONResult->Items[i]);

		this->mePersonen->Lines->Add(pPerson->GetValue("Name")->Value() + ", " + pPerson->GetValue("Vorname")->Value());
	}
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::btnLesenAdressenClick(TObject *Sender)
{
	TJSONObject *pPerson, *pAdresse;

	// Der "Abfragetyp"
	this->BackendQuery->BackendService = "Storage";
	// Aus welcher Parse-Klasse wollen wir Daten lesen?
	this->BackendQuery->BackendClassName = "Adressen";
	// Wie soll sortiert werden?
	this->BackendQuery->QueryLines->Clear();
	this->BackendQuery->QueryLines->Add("include=Person");

	// Die Abfrage ausfuehren
	this->BackendQuery->Execute();

	// Die alten Zeilen aus dem Memofeld loeschen
	this->mePersonen->Lines->Clear();

	// Die Ergebnisliste durchlaufen
	for(int i = 0; i < this->BackendQuery->JSONResult->Count; ++i)
	{
		pAdresse = static_cast<TJSONObject*>(this->BackendQuery->JSONResult->Items[i]);
		pPerson = static_cast<TJSONObject*>(pAdresse->GetValue("Person"));

		this->mePersonen->Lines->Add("Person: " + pPerson->GetValue("Name")->Value() + ", " + pPerson->GetValue("Vorname")->Value());
		this->mePersonen->Lines->Add("Adresse: " + pAdresse->GetValue("Strasse")->Value() + ", " + pAdresse->GetValue("PLZ")->Value() + " " + pAdresse->GetValue("Ort")->Value());
	}
}
//---------------------------------------------------------------------------
